'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SelectOne = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _DropdownPopover = require('./DropdownPopover');

var _DropdownPopover2 = _interopRequireDefault(_DropdownPopover);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectOne = function SelectOne(_ref) {
	var shouldToggleOnHover = _ref.shouldToggleOnHover,
	    transitionOptions = _ref.transitionOptions,
	    onChange = _ref.onChange,
	    _ref$triggerX = _ref.triggerX,
	    triggerX = _ref$triggerX === undefined ? 5 : _ref$triggerX,
	    _ref$paddingX = _ref.paddingX,
	    paddingX = _ref$paddingX === undefined ? 0 : _ref$paddingX,
	    _ref$basewidth = _ref.basewidth,
	    basewidth = _ref$basewidth === undefined ? 20 : _ref$basewidth,
	    buttonProps = _ref.buttonProps,
	    children = _ref.children,
	    pivotFrom = _ref.pivotFrom,
	    debugMode = _ref.debugMode,
	    _renderTrigger = _ref.renderTrigger,
	    className = _ref.className,
	    currentValue = _ref.currentValue,
	    setCurrentValue = _ref.setCurrentValue,
	    _ref$showCurrentValue = _ref.showCurrentValue,
	    showCurrentValue = _ref$showCurrentValue === undefined ? false : _ref$showCurrentValue,
	    options = _ref.options;

	var getChildProps = function getChildProps() {
		var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref2.className,
		    style = _ref2.style,
		    _onClick = _ref2.onClick,
		    value = _ref2.value,
		    props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'value']);

		var isActive = function isActive(value) {
			return value === currentValue;
		};
		//const setCurrentValue = (value) => setCurrentValue(value)
		return (0, _extends3.default)({
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				setCurrentValue(value);
				onChange(value);
				_onClick && _onClick.apply(undefined, [e].concat(args));
			},
			className: (0, _helperFunctions.flippyClass)(isActive(value), 'selectone__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(value), className, 'active', 'inactive') : ''),
			style: style
		}, props);
	};
	//const mappedChildren = React.Children.map(children, (child) =>
	//	React.cloneElement(child, {
	//		className,
	//		onChange,
	//		isActive: (value) => value === currentValue,
	//		setCurrentValue: (value) => setCurrentValue(value),
	//	})
	//)

	//const activeChild = React.Children
	//	.toArray(mappedChildren)
	//	.find((child) => child.props.value === currentValue)
	//console.log(activeChild)
	return _react2.default.createElement(
		_DropdownPopover2.default,
		{
			triggerX: triggerX,
			paddingX: paddingX,
			basewidth: basewidth,
			debugMode: debugMode,
			pivotFrom: pivotFrom,
			transitionOptions: transitionOptions,
			shouldToggleOnHover: shouldToggleOnHover,
			renderTrigger: function renderTrigger(_ref3) {
				var isOn = _ref3.isOn,
				    _getTriggerProps = _ref3.getTriggerProps;
				return _renderTrigger ? _renderTrigger({
					currentValue: currentValue,
					isOn: isOn,
					getTriggerProps: function getTriggerProps() {
						var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

						var className = _ref4.className,
						    props = (0, _objectWithoutProperties3.default)(_ref4, ['className']);
						return _getTriggerProps((0, _extends3.default)({
							className: 'selectone__trigger ' + (className ? className : '')
						}, props));
					}
				}) : _react2.default.createElement(
					'button',
					_getTriggerProps({ className: 'selectone__trigger' }),
					options.find(function (v) {
						return v.value === currentValue.value;
					}).label,
					isOn ? _react2.default.createElement('img', { src: '/static/expandless.svg' }) : _react2.default.createElement('img', { src: '/static/expandmore.svg' })
				);
			},
			parentName: 'select'
		},
		function (_ref5) {
			var toggle = _ref5.toggle;
			return children({ getChildProps: getChildProps, toggle: toggle });
		}
	);
};

exports.SelectOne = SelectOne;
SelectOne.propTypes = {};
SelectOne.defaultProps = {
	buttonType: 'select--default'
};

var enhance = (0, _recompose.compose)(
//onlyUpdateForKeys(`children`),
(0, _recompose.setStatic)('Option', Option), (0, _recompose.withState)('currentValue', 'setCurrentValue', function (_ref6) {
	var currentValue = _ref6.currentValue;
	return currentValue;
}));

exports.default = enhance(SelectOne);