'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _RTGFade = require('./RTGFade');

var _RTGFade2 = _interopRequireDefault(_RTGFade);

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SinglePageModal = function SinglePageModal(_ref) {
  var _ref$onMount = _ref.onMount,
      onMount = _ref$onMount === undefined ? function () {} : _ref$onMount,
      _ref$onUnmount = _ref.onUnmount,
      onUnmount = _ref$onUnmount === undefined ? function () {} : _ref$onUnmount,
      useCustomStyleA = _ref.useCustomStyleA,
      renderTrigger = _ref.renderTrigger,
      defaultCloseModalButton = _ref.defaultCloseModalButton,
      renderCloseModalButton = _ref.renderCloseModalButton,
      renderHeader = _ref.renderHeader,
      dataTestId = _ref.dataTestId,
      renderBody = _ref.renderBody,
      modalIsOpen = _ref.modalIsOpen,
      toggleModal = _ref.toggleModal,
      renderButtons = _ref.renderButtons,
      containerPropsOverride = _ref.containerPropsOverride,
      containerPropsAppend = _ref.containerPropsAppend,
      _ref$backgroundPropsO = _ref.backgroundPropsOverride,
      backgroundPropsOverride = _ref$backgroundPropsO === undefined ? {} : _ref$backgroundPropsO,
      _ref$backgroundPropsA = _ref.backgroundPropsAppend,
      backgroundPropsAppend = _ref$backgroundPropsA === undefined ? {} : _ref$backgroundPropsA,
      useStylesheet = _ref.useStylesheet;

  if (useStylesheet) {
    document.head.appendChild(document.createElement('style')).textContent = _defaultStyles.styleSheet;
  }
  var getTriggerProps = function getTriggerProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref2.onClick,
        className = _ref2.className,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        toggleModal();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'actionmodal__trigger ' + className : 'actionmodal__trigger'

    }, props);
  };
  return _react2.default.createElement(
    _react.Fragment,
    null,
    renderTrigger && renderTrigger({ getTriggerProps: getTriggerProps }),
    _react2.default.createElement(
      _RTGFade2.default,
      (0, _extends3.default)({
        duration: 100,
        style: backgroundPropsAppend.style ? (0, _extends3.default)({}, _defaultStyles.defaultStyles.background, backgroundPropsAppend.style) : _defaultStyles.defaultStyles.background,
        className: backgroundPropsAppend.className ? backgroundPropsAppend.className + ' modal__background' : 'modal__background',
        'in': modalIsOpen,
        onClick: toggleModal
      }, backgroundPropsOverride),
      _react2.default.createElement(_ModalDialog2.default, {
        onMount: onMount,
        onUnmount: onUnmount,
        containerPropsOverride: containerPropsOverride,
        containerPropsAppend: containerPropsAppend,

        dataTestId: dataTestId,
        useCustomStyleA: useCustomStyleA,

        defaultCloseModalButton: defaultCloseModalButton,
        renderHeader: renderHeader,
        renderBody: renderBody,
        toggleModal: toggleModal,
        renderButtons: renderButtons,
        renderCloseModalButton: renderCloseModalButton
      })
    )
  );
};

SinglePageModal.defaultProps = {
  defaultCloseModalButton: true
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withHandlers)({
  toggleModal: function toggleModal(_ref3) {
    var setModalIsOpenTo = _ref3.setModalIsOpenTo;
    return function () {
      console.log('toggling');
      setModalIsOpenTo(function (x) {
        return !x;
      });
    };
  }
}), (0, _recompose.setPropTypes)({ modalIsOpen: _propTypes2.default.bool.isRequired, toggleModal: _propTypes2.default.func.isRequired }));

exports.default = enhance(SinglePageModal);